#ifndef BLOCK_HPP
#define BLOCK_HPP

#include <oiran/linda/graphics.hpp>
#include "ball.hpp"
#include "defs.hpp"


class block_t
{
public:
	block_t(const vector_type& left_top);
	virtual ~block_t();

	virtual void draw(oiran::linda::graphics_t& g) = 0;
	virtual bool collision_detection(ball_t& ball, bool& recheck) = 0;

	virtual char id() const = 0;

	void valid(bool f) { M_valid = f; }
	bool valid() const { return M_valid; }

	vector_type center() const
	{ return M_left_top + vector_type(block_size / 2, block_size / 2); }

protected:
	vector_type M_left_top;

private:
	bool M_valid;
};


class wall_t : public block_t
{
public:
	wall_t(const vector_type& left_top);

	void draw(oiran::linda::graphics_t& g);
	bool collision_detection(ball_t& ball, bool& recheck);

	char id() const { return wall; }
};


class normal_block_t : public block_t
{
public:
	normal_block_t(const vector_type& left_top);

	void draw(oiran::linda::graphics_t& g);
	bool collision_detection(ball_t& ball, bool& recheck);

	char id() const { return normal; }
};


block_t* create_block(char id, const vector_type& left_top);


#endif // BLOCK_HPP
