#ifndef FIELD_HPP
#define FIELD_HPP

#include <oiran/noncopyable.hpp>
#include <oiran/linda/graphics.hpp>
#include "ball.hpp"
#include "block.hpp"
#include "defs.hpp"


class field_t
{
public:
	field_t(int stage);
	~field_t();

	void load();
	void save();
	void clear();
	void put(char id, int x, int y);

	void draw(oiran::linda::graphics_t& g);
	void collision_detection(ball_t& ball);

	bool valid() const { return M_valid; }
	bool is_game_clear() const;

private:
	OIRAN_NONCOPYABLE(field_t);

private:
	int M_stage;
	block_t* M_blocks[field_width * field_height];
	bool M_valid;
};


#endif // FIELD_HPP
