#ifndef OIRAN_LINDA_GRAPHICS_HPP
#define OIRAN_LINDA_GRAPHICS_HPP

#include <oiran/singleton.hpp>

namespace oiran { namespace linda {


	class graphics_t : public singleton_t<graphics_t>
	{
	public:
		void clear();
		void flip();

		void clear_color(double r, double g, double b, double a = 0);
		void clear_color(unsigned int hex, double alpha = 0);

		void color(double r, double g, double b, double a = 1);
		void color(unsigned int hex, double alpha = 1);

		void point(double x, double y);
		void line(double x1, double y1, double x2, double y2);
		void triangle(double x1, double y1,
				double x2, double y2,
				double x3, double y3);
		void rect(double x, double y, double w, double h);
		void quad(double x1, double y1,
				double x2, double y2,
				double x3, double y3,
				double x4, double y4);

		void smooth();
		void no_smooth();
		void stroke();
		void fill();

		void point_size(double value);

		void push_matrix();
		void pop_matrix();

		void rotate(double angle);
		void translate(double x, double y);
		void scale(double value);
		void scale(double x, double y);
	};


}} // namespace oiran::linda.

#endif // OIRAN_LINDA_GRAPHICS_HPP
