#include <algorithm>
#include "keyboard.hpp"

namespace oiran { namespace linda {


keyboard_t::keyboard_t()
{
	std::fill(M_keys, M_keys + SDLK_LAST, 0);
}

void
keyboard_t::update()
{
	Uint8* keys = SDL_GetKeyState(0);
	for(int i = 0; i < SDLK_LAST; ++i)
	{
		if(*(keys + i))
			M_keys[i] = std::max(1, M_keys[i] + 1);
		else
			M_keys[i] = std::min(0, M_keys[i] - 1);
	}
}


}} // namespace oiran::linda.
