#ifndef OIRAN_LINDA_KEYBOARD_HPP
#define OIRAN_LINDA_KEYBOARD_HPP

#include <SDL.h>

namespace oiran { namespace linda {


	class keyboard_t
	{
	public:
		keyboard_t();

		void update();

		int get(int id) const { return M_keys[id]; }
		bool is_pressed(int id) const { return M_keys[id] >= 1; }
		bool is_pushed(int id) const { return M_keys[id] == 1; }
		bool is_released(int id) const { return M_keys[id] <= 0; }
		bool is_pulled(int id) const { return M_keys[id] == 0; }

	private:
		int M_keys[SDLK_LAST];
	};


}} // namespace oiran::linda.

#endif // OIRAN_LINDA_KEYBOARD_HPP
