#include <SDL.h>
#include <algorithm>
#include "mouse.hpp"

namespace oiran { namespace linda {


mouse_t::mouse_t() :
		M_x(0),
		M_y(0)
{
	std::fill(M_buttons, M_buttons + number_of_buttons, 0);
}

void
mouse_t::update()
{
	Uint8 buttons = SDL_GetMouseState(&M_x, &M_y);
	for(int i = 0; i < number_of_buttons; ++i)
	{
		if(buttons & SDL_BUTTON(i + 1))
			M_buttons[i] = std::max(1, M_buttons[i] + 1);
		else
			M_buttons[i] = std::min(0, M_buttons[i] - 1);
	}
}


}} // namespace oiran::linda.
