#ifndef OIRAN_LINDA_MOUSE_HPP
#define OIRAN_LINDA_MOUSE_HPP

namespace oiran { namespace linda {


	class mouse_t
	{
	public:
		enum {
			left,
			middle,
			right,
			number_of_buttons
		};

		mouse_t();

		void update();

		int x() const { return M_x; }
		int y() const { return M_y; }

		int get(int id) const { return M_buttons[id]; }
		bool is_pressed(int id) const { return M_buttons[id] >= 1; }
		bool is_pushed(int id) const { return M_buttons[id] == 1; }
		bool is_released(int id) const { return M_buttons[id] <= 0; }
		bool is_pulled(int id) const { return M_buttons[id] == 0; }

	private:
		int M_x;
		int M_y;
		int M_buttons[number_of_buttons];
	};


}} // namespace oiran::linda.

#endif // OIRAN_LINDA_KEYBOARD_HPP
